Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## com.amazonaws.services.s3.model
Class AccessControlList

    java.lang.Object
      com.amazonaws.services.s3.model.AccessControlList

All Implemented Interfaces:
  Serializable

    public class AccessControlList

extends Object
implements Serializable

Represents an Amazon S3 Access Control List (ACL), including the ACL's set of grantees and the permissions assigned to each grantee.

Each bucket and object in Amazon S3 has an ACL that defines its access control policy. When a request is made, Amazon S3 authenticates the request using its standard authentication procedure and then checks the ACL to verify the sender was granted access to the bucket or object. If the sender is approved, the request proceeds. Otherwise, Amazon S3 returns an error.

An ACL is a list of grants. A grant consists of one grantee and one permission. ACLs only grant permissions; they do not deny them.

For convenience, some commonly used Access Control Lists are defined in `CannedAccessControlList`.

Note: Bucket and object ACLs are completely independent; an object does not inherit the ACL from its bucket. For example, if you create a bucket and grant write access to another user, you will not be able to access the user's objects unless the user explicitly grants access. This also applies if you grant anonymous write access to a bucket. Only the user "anonymous" will be able to access objects the user created unless permission is explicitly granted to the bucket owner.

Important: We highly recommend that you do not grant the anonymous group write access to your buckets as you will have no control over the objects others can store and their associated charges. For more information, see Grantees and Permissions

See Also:
  `CannedAccessControlList`, Serialized Form

Constructor Summary
`AccessControlList()`

Method Summary
`Set<Grant>` | `getGrants()`
`Owner` | `getOwner()` Every bucket and object in Amazon S3 has an owner, the user that created the bucket or object.
`void` | `grantAllPermissions(Grant... grantsVarArg)` Adds a set of grantee/permission pairs to the ACL, where each item in the set is a `Grant` object.
`void` | `grantPermission(Grantee grantee, Permission permission)` Adds a grantee to the ACL with the given permission.
`void` | `revokeAllPermissions(Grantee grantee)` Revokes the permissions of a grantee by removing the grantee from the ACL.
`void` | `setOwner(Owner owner)` Sets the owner on this ACL.
`String` | `toString()` Returns a string representation of the ACL contents, useful for debugging.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

Constructor Detail

### AccessControlList

    public AccessControlList()

Method Detail

### getOwner

    public Owner getOwner()

  Every bucket and object in Amazon S3 has an owner, the user that created the bucket or object. The owner of a bucket or object cannot be changed. However, if the object is overwritten by another user (deleted and rewritten), the new object will have a new owner.

  Note: Even the owner is subject to the ACL. For example, if an owner does not have `Permission.Read` access to an object, the owner cannot read that object. However, the owner of an object always has write access to the access control policy (`Permission.WriteAcp`) and can change the ACL to read the object.

  Returns:
    The owner for this AccessControlList.

### setOwner

    public void setOwner(Owner owner)

  Sets the owner on this ACL. This method is only intended for internal use by the library. The owner of a bucket or object cannot be changed. However the object can be overwritten by the new desired owner (deleted and rewritten).

  Parameters:
    `owner` - The owner for this ACL.

### grantPermission

    public void grantPermission(Grantee grantee,
                                Permission permission)

  Adds a grantee to the ACL with the given permission. If this ACL already contains the grantee (i.e. the same grantee object) the permission for the grantee will be updated.

  Parameters:
    `grantee` - the grantee to whom the permission will apply.
    `permission` - the permission to apply to the grantee.

### grantAllPermissions

    public void grantAllPermissions(Grant... grantsVarArg)

  Adds a set of grantee/permission pairs to the ACL, where each item in the set is a `Grant` object.

  Parameters:
    `grants` - a collection of `Grant` objects

### revokeAllPermissions

    public void revokeAllPermissions(Grantee grantee)

  Revokes the permissions of a grantee by removing the grantee from the ACL.

  Parameters:
    `grantee` - the grantee to remove from this ACL.

### getGrants

    public Set<Grant> getGrants()

  Returns:
    the set of `Grant` objects in this ACL.

### toString

    public String toString()

  Returns a string representation of the ACL contents, useful for debugging.

  Overrides:
    `toString` in class `Object`

Overview | Package | Class | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

Copyright © 2010 Amazon Web Services, Inc. All Rights Reserved.